#!/usr/bin/env python

import dtest
import time
import logging

# Here begins the test
dtest.DTestMaster.logger.setLevel(level=logging.ERROR)
dtest.DTester.logger.setLevel(level=logging.ERROR)

def myCustomStep(dtester, *args, **kwargs):
   dtester.ok(True,"myCustomStep")

def myInvalidCustomStep(bla, blo):
   print "myInvalidCustomStep"

def mySleepStep(dtester):
   time.sleep(6)

# Create as many DTester as you need
tester1     = dtest.DTester("DTester1")
tester2     = dtest.DTester("DTester2")

# Describe the run step(s)
tester1.addRunStep("barrier","aBarrier")
tester2.addRunStep("barrier","aBarrier")
tester2.addRunStep("ok",True,skip="--SKIPPED step--")
tester2.addRunStep("ok",False,desc="here is a failure")
tester1.addRunStep(myCustomStep)
tester1.nb_steps += 1
try:
   tester1.addRunStep(myInvalidCustomStep)
except dtest.DTester.InvalidStepFunction, e:
   print "## OK not adding the run step:", repr(myInvalidCustomStep)
   print "## Since it raises : ", repr(e)   

tester2.addRunStep("barrier","anotherBarrier")
tester2.addRunStep("ok",True,todo="--TODO step--")

# Thoses step will make tester2 timeout for sure
tester1.addRunStep("barrier","wait4me4ever")
tester2.addRunStep("barrier","wait4me4ever")
tester1.addRunStep(mySleepStep)
tester1.addRunStep("barrier","timedBarrier",10.6)
tester2.addRunStep("barrier","timedBarrier",1.5)
tester2.addRunStep("ok",True,desc="--END step--")


myDTestMaster = dtest.DTestMaster()
myDTestMaster.register(tester1)
myDTestMaster.register(tester2)
myDTestMaster.startTestSequence()
myDTestMaster.waitTestSequenceEnd()


