import threading
from threading import Thread
import sys
import os
import time
import signal
from StringIO import StringIO
import logging
import inspect
import re
from DTester import DTester
    
class DTesterLocal(DTester):
    """
    A DTester which may run command on local machine
    """
    def __init__ (self,name,command='dir',timeout=None):
        super(DTesterLocal,self).__init__(name,command,timeout)   

    def runCommand(self, command=None, environ=None):
        if (command!=None):
            self.setCommand(command)
        if (environ!=None):
            self.setEnviron(environ)
        try:
            self.logger.debug("command <%s> will be Popen-ed" % command)
            self.child = subprocess.Popen(self.command,
                                          bufsize=0,
                                          stdin  =subprocess.PIPE,
                                          stdout =subprocess.PIPE,
                                          stderr =subprocess.PIPE,
                                          env    =self.environ)
            self.stdin  = self.child.stdin
            self.stdout = self.child.stdout
            self.stderr = self.child.stderr
            self.logger.info("command <%s> started" % command)
            return True
        except OSError, err:
            self.child = None
            self.stderr = StringIO("Cannot execute command:\n  -->"+self.command+"\nReason:\n  -->"+err.__class__.__name__+str(err)+"\n")
            self.logger.warning("cannot execute: <%s>" % command)
            return False
    
    def sendToCommand(self, string):
        raise NotImplementedError, "sendToCommand not IMPLEMENTED" 
        return False
    
    def waitCommandTermination(self, timeout=None):
        if self.child != None:
            self.child.wait()
            if self.child.returncode == None:
                self.logger.warning("Command <%s> did not terminate properly." % self.command)
            else:
                self.logger.info("Command <%s> terminated." % self.command)
            return True
        else:        
            return True
    
    def terminateCommand(self):
        if self.child != None and self.child.returncode==None:
            os.kill(self.child.pid,signal.SIGINT)
            self.stdin.close()
        return True
        
