
import threading
from threading import Thread
from paramiko  import SSHClient
from DTester import DTester
import sys
import os
import time
import signal
import subprocess
from StringIO import StringIO
import logging
import inspect
import re
import socket

class DTesterSSH(DTester):
    """
    An SSH DTester which may run command through an SSH connection
    """
    logging.getLogger("paramiko.transport").addHandler(DTester.sh)
    def __init__ (self,name,user,host='localhost',command='dir',timeout=10):
        super(DTesterSSH,self).__init__(name,command,timeout)
        self.host        = host
        self.user        = user
        self.child       = None
    

    def runCommand(self , command=None, environ=None):
        
        if (command!=None):
            self.setCommand(command)
        if (environ!=None):
            self.setEnviron(environ)

        self.child       = SSHClient()
        ##self.child.set_log_channel("DTester")
        self.child.load_system_host_keys()
        try:
            self.child.connect(self.host,username=self.user)
        except socket.error, err:
            return False

        self.channel = self.child.invoke_shell('vt100',80,300)
        self.channel.sendall(command+"\n")
        return True

    def expectFromCommand(self, pattern, timeout=None):        
        pat       = re.compile(pattern)
        monitored = StringIO("")
        self.expectDidTimeOut = False
        if timeout!=None:
            t = self.createExpectTimer(timeout,msg="while <%s> expecting <%s>." % (self.getName(),pattern))
            t.start()
            
        while (not pat.search(monitored.getvalue())) and (not self.expectDidTimeOut):
            if self.channel.recv_ready():
                monitored.write(self.channel.recv(1))
            else:
                #self.logger.debug("Monitored = %s" % monitored.getvalue())
                time.sleep(1)

        if self.expectDidTimeOut:
            self.logger.debug("Monitored = %s" % monitored.getvalue())
            return False
        else:
            if timeout != None:
                t.cancel()
            self.logger.debug("Monitored MATCHED = %s" % monitored.getvalue())
            return True

    def sendToCommand(self, string):
        raise NotImplementedError, "sendToCommand not IMPLEMENTED" 
        return False
    
    def waitCommandTermination(self, timeout=None):
        if self.child != None:
            while self.channel.recv_ready():
                self.channel.recv(1)
            self.channel.close()
            return True
        else:        
            return True
    
    def terminateCommand(self):
        if self.child != None:
            self.channel.sendall(chr(03))
            self.channel.sendall("exit")
            return True
        else:
            return True
